


import java.awt.*;
import java.text.*;
import java.util.*;
import javax.swing.*;


//****************************************************************************************
//****************************************************************************************



public class MiniFrakt3 extends java.applet.Applet {


// variante =3 fr Start, keine weitere action
// nderungen 3<->4: Rechnungskern, Anfangswerte, Farbkodierung Pict 9, TextInfo:Text Fraktal3.htm,Farbkod. + Gleichung
// 4<->1 zustzlich alles mit TextInfo p,t raus,
//  unf Farbkodierung Bild 2 ndern + im TextInfo

	int[] bi;
	double[] dbi;

    MiniFrakt3Panel panel;



//______________________________________________________________________________________

    public void init() {

	double brx = 10, bry = 10, vsx = -0.904816115646875, vsy = 8.40956775E-4, vsp, vst, par = 10;
	double CCx = 0.053125, CCy = -0.053125, CCz = 0, ZOOM=0.5, maxabs = 1.0E9, paramStep=0.01;
	int ianzmax = 100, farbtab = 3, colshift = 0, selectP = 6;
	int AnzahlBilder=36, fa = 128, fmin = 0, vari = 1, ixe = 100, wZOOM=1, wParam=0, delayS=3;
	String s;
	bi = new int[12];
	dbi = new double[13];


	vsp = vsx; vst = vsy;

	panel = new MiniFrakt3Panel();

	//setLayout(new BorderLayout());
	setLayout(new GridLayout(1,1));
	//add("Center",panel);
	add(panel);

	try {
				panel.setBackground(new Color(Integer.parseInt(getParameter("bgColor"),16)));
			} catch (Exception E) { }



	s = getParameter("widtX");
	if (s != null) brx = Double.valueOf(s).doubleValue();

	s = getParameter("heightY");
	if (s != null) bry = Double.valueOf(s).doubleValue();

	s = getParameter("PointX");
	if (s != null) vsx = Double.valueOf(s).doubleValue();

	s = getParameter("PointY");
	if (s != null) vsy = Double.valueOf(s).doubleValue();

	s = getParameter("PointP");
	if (s != null) vsp = Double.valueOf(s).doubleValue();

	s = getParameter("PointT");
	if (s != null) vst = Double.valueOf(s).doubleValue();

	s = getParameter("connectPARAM");
	if (s != null) par = Double.valueOf(s).doubleValue();

		s = getParameter("CxPoint");
	if (s != null) CCx = Double.valueOf(s).doubleValue();

		s = getParameter("CyPoint");
	if (s != null) CCy = Double.valueOf(s).doubleValue();

CCz = 0;

		s = getParameter("ZOOMperPict");
	if (s != null) ZOOM = Double.valueOf(s).doubleValue();

	s = getParameter("max_(X+Y)");
	if (s != null) maxabs = Double.valueOf(s).doubleValue();

	s = getParameter("PARAMstep");
	if (s != null) paramStep = Double.valueOf(s).doubleValue();



		dbi[0]=brx;
		dbi[1]=bry;
		dbi[2]=vsx;
		dbi[3]=vsy;
		dbi[4]=vsp;
		dbi[5]=vst;
		dbi[6]=par;
		dbi[7]=CCx;
		dbi[8]=CCy;
		dbi[9]=CCz;
		dbi[10]=ZOOM;
		dbi[11]=maxabs;
		dbi[12]=paramStep;


 s = getParameter("max_it");
 if (s != null) ianzmax = Integer.parseInt(s);

 s = getParameter("colTabNr");
 if (s != null) farbtab = Integer.parseInt(s);

 s = getParameter("colShift");
 if (s != null) colshift = Integer.parseInt(s);

 s = getParameter("selectPict");
 if (s != null) selectP = Integer.parseInt(s);

 s = getParameter("picts");
 if (s != null) AnzahlBilder = Integer.parseInt(s);

 s = getParameter("colFact");
 if (s != null) fa = Integer.parseInt(s);

 s = getParameter("colAdd");
 if (s != null) fmin = Integer.parseInt(s);

 s = getParameter("variant");
 if (s != null) vari = Integer.parseInt(s);

 s = getParameter("withZOOM");
 if (s != null) wZOOM = Integer.parseInt(s);

  s = getParameter("withPARAM");
 if (s != null) wParam = Integer.parseInt(s);

  s = getParameter("delayStop");
 if (s != null) delayS = Integer.parseInt(s);

 ixe = getSize().width;

 		bi[0]=ianzmax;
 		bi[1]=delayS;
 		bi[2]=ixe;
 		bi[3]=farbtab;
 		bi[4]=colshift;
 		bi[5]=selectP;
 		bi[6]=AnzahlBilder;
 		bi[7]=fa;
 		bi[8]=fmin;
 		bi[9]=vari;
 		bi[10]=wZOOM;
		bi[11]=wParam;


		 panel.setFraktParams(dbi, bi);


 }

//______________________________________________________________________________________

	public void stop() {


        remove(panel);

	}

//______________________________________________________________________________________

    public void destroy() {

        remove(panel);
    }

//______________________________________________________________________________________


  public void start() {

	 panel.setFraktParams(dbi, bi);


	}

//______________________________________________________________________________________



    public String getAppletInfo() {
        return "MiniFrakt3 von Gabi Mueller, info@alveo.de, http://www.aladin24.de/applets";
    }

 }


//****************************************************************************************
//****************************************************************************************



class MiniFrakt3Panel extends Panel {


 	double PI = Math.PI;
	double ZPI = 2 * PI;
	double PIH = PI / 2;
	int ANZFARBTAB = 24;


	int ianzmax, groesse, farbtab, colshift=1, selectPicture, zoom, fact, fmin, AnzahlBilder, wZOOM, wParam;
	double brx0, brx, bry, vsx, vsy, vsp, vst, par, param0, ZOOM, CCx=0, CCy=0, CCz=0, maxabs, paramStep;

	int variante, pmod = 2, exdat, exdaty, ipic = 0;
	int ixe, iye, delayS;
	double xP = 0, yP = 0;
	int time = 24, farbtab0 = 0, startx, starty;

	int[] kx = new int[10];
	int[] ky = new int[10];
	int[] kx0 = new int[10];
	int[] ky0 = new int[10];

	double[] bildX;
	double[] bildY;
	double[] bildZ;
	int[] ibild;


	boolean rotate = false, julia = false;



//______________________________________________________________________________________


	public MiniFrakt3Panel() {


		repaint();

	}

//______________________________________________________________________________________


public void setFraktParams(double[] db, int[] b){

	double h1,h2;


		brx0=db[0];
		bry=db[1];
		vsx=db[2];
		vsy=db[3];
		vsp=db[4];
		vst=db[5];
		par=db[6];
		CCx=db[7];
		CCy=db[8];
		CCz=db[9];
		ZOOM=db[10]; //b[6];
		maxabs=db[11];
		paramStep=db[12];

		ianzmax=b[0];
		delayS=b[1];
		groesse=b[2];
		farbtab = b[3];
		colshift=b[4];
		selectPicture=b[5];
		AnzahlBilder=b[6];
		fact=b[7];
		fmin=b[8];
	int vari=b[9];
	if (vari == 1) {julia = false; rotate = false;}
	if (vari == 2) {julia = true; rotate = false;}
	if (vari == 3) {julia = false; rotate = true;}
	if (vari == 4) {julia = true; rotate = true;}


	variante = 4; // fr paint

		wZOOM=b[10];
		wParam=b[11];


		repaint();


};


//______________________________________________________________________________________



	private void calculate() {

	// Version mit x,y,p,t in der Auswertung, Ausgabe als x,y,z

	// Abbruch:	iA=ianzmax  bei Chaos
	//			iA=ianzmax+10 bei Divergenz
	//			iA=ianzmax+100 bei Division durch Null
	//			iA ansonsten ist Anzahl der Iterationen


		int i, j, ix, iy, index;
		int ianz, iA;

		double swx, swy, genau, genau0 = 20000;
		double x, y, xalt, yalt, dd, Cx=0, Cy=0, Cp=0, Ct=0, bx, by, bp, bt, bx0, by0, bp0;
		double p, t, palt, talt, param;
		double h1, h2, a, b, qx, qy, q3x, q3y, u, v, d, e, fsb, xrett, yrett;
		double Bix, Biy, Biz, Bir, maxr;
		boolean abbr, idiverg, idivNull;


		ixe = groesse;
		if (selectPicture == 0) ixe = (groesse / 3) - 2;
		if ((brx < 0) | (bry < 0)) return;

		iye = ixe; maxr=0;
		bildX = new double[ixe * iye + 1];
		bildY = new double[ixe * iye + 1];
		bildZ = new double[ixe * iye + 1];
		ibild = new int[ixe * iye + 1];

		swx = brx / ixe;
		swy = bry / iye;
		genau = (swx + swy) / genau0;
		bx0 = -brx / 2 - swx + vsx;
		bp0 = -brx / 2 - swx + vsp;
		by = bry / 2 + vsy;
		bt = bry / 2 + vst;
		param = param0;
		if(julia) {Cx = CCx; Cy = CCy; Cp = CCx; Ct = CCy;};

// System.out.println("genau=" + genau);



// Berechnung des Bildes (iy , ix ):

	index=-1;

	for (iy=0; iy < iye; iy++) {						// Neue Zeilen

		 by -= swy; bx = bx0; bt -= swy; bp = bp0;


		for (ix=0; (ix < ixe); ix++) {			// Neue Punkte

		  bx += swx; bp += swx;

		  ianz = 0;

		if(julia)
		{x = bx; y = by; xalt = x; yalt = y; p = bp; t = bt; palt = p; talt = t;}
		else
		{Cx = bx; Cy = by; Cp = bp; Ct = bt;
		 x = 0; y = 0; xalt = 0; yalt = 0; p = 0; t = 0; palt = 0; talt = 0;};

		abbr = false; idiverg = false; idivNull=false;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	do {											// Neue Iterationen

		   ianz++;

		   if (ianz > ianzmax) abbr = true;;		// Abbruch wegen Chaos

		   xalt = x; yalt = y; palt = p; talt = t;

// Zwilling 1:

		a = Cx * (1 + param * p);	// C(param)=a+ib;
		b = Cy * (1 - param * t);

		qx = x * x - y * y;
		qy = 2 * x * y;
		q3x = qx * x - qy * y;
		q3y = qx * y + qy * x;
		u = x + a;
		v = y + b;
		d = a * q3x - b * q3y + 1;
		e = a * q3y + b * q3x;

		fsb = d * d + e * e;
		if (fsb < 1E-10) {idivNull=true; abbr=true; break;}	// Abbruch wegen Division durch Null

		xrett = (u * d + v * e) / fsb;
		yrett = (v * d - u * e) / fsb;

// Zwilling 2:

		a = Cp * (1 + param * x);	// C(param)=a+ib;
		b = Ct * (1 - param * y);
		x = p;
		y = t;

		qx = x * x - y * y;
		qy = 2 * x * y;
		q3x = qx * x - qy * y;
		q3y = qx * y + qy * x;
		u = x + a;
		v = y + b;
		d = a * q3x - b * q3y + 1;
		e = a * q3y + b * q3x;

		fsb = d * d + e * e;
		if (fsb < 1E-10) {idivNull=true; abbr=true; break;}	// Abbruch wegen Division durch Null
		p = (u * d + v * e) / fsb;
		t = (v * d - u * e) / fsb;

		x = xrett;
		y = yrett;



		if ( (Math.abs(x) + Math.abs(y) + Math.abs(p) + Math.abs(t)) > maxabs) {idiverg = true; abbr = true;}	// Abbruch wegen Divergenz
		dd = Math.abs(xalt - x) + Math.abs(yalt - y) + Math.abs(palt - p) + Math.abs(talt - t);

	}

	while ((dd > genau) & (!abbr));  //  Ende der do - Schleife => Neue Iteration
		// Ende Punkt

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		iA = ianz + 256;
		if (idiverg) iA = iA + 128; // str = Integer.toString(ix);
		if (idivNull) iA = iA + 64;


		       Bix=x;   Biy=y;   Biz=p;					// ACHTUNG: genauso kann t als z genommen werden
		   	   Bir=Math.sqrt(Bix*Bix+Biy*Biy+Biz*Biz);

 				index++;
						bildX[index] = Bix;
						bildY[index] = Biy;
						bildZ[index] = Biz;
						ibild[index] = iA;

					if(!idiverg) {
						if (Bir > maxr) maxr = Bir;
						};


		};  //   Ende Punkt  for (ix




	}; //	WEND   Ende Zeile  for (iy, am Schlu auch Ende Bild


		bildX[0] = maxr;

// Speichern des Datensatzes (fr back-button):




}

//______________________________________________________________________________________


public void paint(Graphics g) {

	int[] colR = new int[256];
	int[] colG = new int[256];
	int[] colB = new int[256];

	int j, jj, ix, iy, loop0=0;
	int kxA, kxB, iA, igr;
	int width = 600;
	int height = 600;
	double Bildx, Bildy, Bildz, Bildr;


do  {

	brx = brx0;
	param0 = par;

for (int ibil = 0; ibil <  AnzahlBilder; ibil++) {

		if ((wZOOM == 1) & (ibil > 0)) brx *=ZOOM;

		if ((wParam == 1) & (ibil > 0)) param0 += paramStep;

		bry = brx;

		calculate();



//	testeDate();
	if (brx < 0 ) {textInfo(g); break;}

		kxA = ixe + 3; kxB = 2 * kxA; startx=0; starty=0;
		kx0[1] = startx;		kx0[4] = kx0[1]; kx0[7] = kx0[1];
		kx0[2] = kxA + startx;	kx0[5] = kx0[2]; kx0[8] = kx0[2];
		kx0[3] = kxB + startx;	kx0[6] = kx0[3]; kx0[9] = kx0[3];

		ky0[1] = starty;       ky0[2] = ky0[1]; ky0[3] = ky0[1];
		ky0[4] = kxA + starty; ky0[5] = ky0[4]; ky0[6] = ky0[4];
		ky0[7] = kxB + starty; ky0[8] = ky0[7]; ky0[9] = ky0[7];


			switch (farbtab) {

				case 14: { getTabIdeal(0, 255, colR, colG, colB); break;}
				case 15: { getTabIdeal(1, 255, colR, colG, colB); break;}
				case 24: { getTabKontrast(1, 255, colR, colG, colB); break;}

				default:
				getTabSinus(farbtab, 255, colR, colG, colB);
			};



	getPresentModus(colshift, 255, colR, colG, colB);



// Bildausgabe:
	if (selectPicture == 0)						// Fr 9 Bilder
		{

			if (!rotate) paint9Picture(0, iye, 0, ixe, colR, colG, colB, g);
			else
			paint9PictureRot(ixe, 0, 0, iye, colR, colG, colB, g);



		}		// ende if (selectP
		else {													// fr 1 Bild


			if (!rotate) paint1Picture(0, iye, 0, ixe, colR, colG, colB, g);
			else
			paint1PictureRot(ixe, 0, 0, iye, colR, colG, colB, g);



		}			// ende else


		delayStop(1000*delayS);


			if (ibil == AnzahlBilder-1) {
				delayStop(8000);
				textInfo(g);
				delayStop(8000);
			}


}; 		// Ende ibil - Schleife mit ZOOM

}			// Ende while loop0  (loop0 wird nie gendert)
while ((loop0 < 1) & (brx > 0));


}	// Ende paint

//______________________________________________________________________________________


		private void paint9Picture(int start1, int end1, int start2, int end2, int[] coR, int[] coG, int[] coB, Graphics g) {
		int igr;
			int ibi = -1; int icf = 0;
			for (int iy = start1; iy < end1; iy++) {

			for (int ix = start2; ix < end2; ix++) {

				ibi++;
				for (int jj = 1; jj < 10; jj++) {

					igr = getPixelColor(jj,ibi);

					icf = grenz(igr);

					g.setColor(new Color(coR[icf], coG[icf], coB[icf]));

				kx[jj]=ix+kx0[jj];
				ky[jj]=iy+ky0[jj];
				g.drawLine(kx[jj],ky[jj],kx[jj],ky[jj]);
				}	// for jj
			}		// for ix
			};		// for iy


}


//______________________________________________________________________________________



		private void paint1Picture(int start1, int end1, int start2, int end2, int[] coR, int[] coG, int[] coB, Graphics g) {
		int igr;

			int ibi = -1; int icf = 0;
						for (int iy = start1; iy < end1; iy++) {

							for (int ix = start2; ix < end2; ix++) {

							ibi++;

							igr = getPixelColor(selectPicture,ibi);

							icf = grenz(igr);

							g.setColor(new Color(coR[icf], coG[icf], coB[icf]));

							kx[1]=ix+kx0[1];
							ky[1]=iy+ky0[1];
							g.drawLine(kx[1],ky[1],kx[1],ky[1]);

							}		// for ix
							};		// for iy

}

//______________________________________________________________________________________


		private void paint9PictureRot(int start1, int end1, int start2, int end2, int[] coR, int[] coG, int[] coB, Graphics g) {
		int igr;
			int ibi = -1; int icf = 0;
			for (int iy = (start1-1); iy > (end1-1); iy--) {

			for (int ix = start2; ix < end2; ix++) {

				ibi++;
				for (int jj = 1; jj < 10; jj++) {

					igr = getPixelColor(jj,ibi);

					icf = grenz(igr);

					g.setColor(new Color(coR[icf], coG[icf], coB[icf]));

				kx[jj]=ix+kx0[jj];
				ky[jj]=iy+ky0[jj];
				g.drawLine(ky[jj],kx[jj],ky[jj],kx[jj]);
				}	// for jj
			}		// for ix
			};		// for iy


}


//______________________________________________________________________________________



		private void paint1PictureRot(int start1, int end1, int start2, int end2, int[] coR, int[] coG, int[] coB, Graphics g) {
		int igr;

			int ibi = -1; int icf = 0;
						for (int iy = (start1-1); iy > (end1-1); iy--) {

							for (int ix = start2; ix < end2; ix++) {

							ibi++;

							igr = getPixelColor(selectPicture,ibi);

							icf = grenz(igr);

							g.setColor(new Color(coR[icf], coG[icf], coB[icf]));

							kx[1]=ix+kx0[1];
							ky[1]=iy+ky0[1];
							g.drawLine(ky[1],kx[1],ky[1],kx[1]);

							}		// for ix
							};		// for iy

}



//______________________________________________________________________________________




	private int grenz(int igr) {
		if (igr > 255) igr=255;
		if (igr < 1) igr=0;

	return igr;
	}


//______________________________________________________________________________________



	private int getPixelColor(int Nr, int ibi) {

		double Bildx = bildX[ibi];
		double Bildy = bildY[ibi];
		double Bildz = bildZ[ibi];
		double Bildr = Math.sqrt(Bildx*Bildx + Bildy*Bildy + Bildz*Bildz);
		int iA = ibild[ibi] - 256;
		double fa = (double)fact;


		int igr = 0;

		switch (Nr) {

		case 1: {
			igr = (int)(fa*moduloI(iA,(int)(256/fa)));
			break; }
		case 2: {
			igr = (int)(fa*moduloI(iA,4));
			break; }
		case 3: {
			igr = moduloI(iA,255);
			break; }


		case 4: {
			if (Bildx < 0) igr=255;
			if (Math.abs(Bildx) < 1) igr=0;
			if (Math.abs(Bildx) > 1) igr=(int)(fa*Math.log(Math.abs(Bildx)-fmin));
		    break; }
		case 5: {
			if (Bildy < 0) igr=255;
			if (Math.abs(Bildy) < 1) igr=0;
			if (Math.abs(Bildy) > 1) igr=(int)(fa*Math.log(Math.abs(Bildy)-fmin));
		   	break; }
		case 6: {
			if (Bildr < 0) igr=255;
			if (Math.abs(Bildr) < 1) igr=0;
			if (Math.abs(Bildr) > 1) igr=(int)(fa*Math.log(Bildr)-fmin);
		  	break; }


		case 7: {
			if (Bildx > 0) igr=0;
			if (Bildx < 0) igr=64;
			if (Bildx > 1) igr=(int)(fa*Math.log(Bildx)-fmin);
		    break; }
		case 8: {
			if (Bildy > 0) igr=0;
			if (Bildy < 0) igr=64;
		    if (Bildy > 1) igr=(int)(fa*Math.log(Bildy)-fmin);
		   	break; }
		case 9: {

			if (Bildr < 0) igr=255;
			if (Math.abs(Bildr) < 1) igr=(int)(fa*2*Bildr-fmin);
			if (Math.abs(Bildr) > 1) igr=0;
			break; }


	      //  if (Bildz > 0) igr=0;
		  //  if (Bildz < 0) igr=64;
		  //  if (Bildz > 1) igr=fa*(int)(Math.log(Bildz));
		  //  break; }

		}
	return igr;
	}


//______________________________________________________________________________________



	private void textInfo(Graphics g) {

		int tx=30; int ty=0;
		Font f1 = new Font("Dialog", Font.BOLD, 12);
		Font f2	= new Font("SansSerif", Font.PLAIN, 10);
		Font f3	= new Font("SansSerif", Font.PLAIN, 12);


		g.setColor(Color.white);
	 	g.fillRect(0,0,600,650);

		g.setColor(Color.black);
		g.setFont(f1);
		g.drawString("Program-Info", 0,ty+=15);
		g.setFont(f2);
		g.drawString("see at", 0,ty+=10);
		g.drawString("aladin24.de/", 0,ty+=10);
		g.drawString("applets/fraktale/", 0,ty+=10);
		g.drawString("Fraktal3.htm", 0,ty+=10);
		g.drawString("(main-software)", 0,ty+=10);
		g.drawString("or widthX < 0    and", 0,ty+=15);
		g.drawString("600 x 600-Applet", 0,ty+=10);

		g.setFont(f2);
		g.drawString("For", tx,ty+=20);
		g.drawString("  Complex Z1 =  X + iY", tx,ty+=15);
		g.drawString("  Complex Z2 =  P + iT", tx,ty+=15);
		g.drawString("  Complex Cxy = Cx + iCx", tx,ty+=15);
		g.drawString("  Complex Cpt = Cp + iCt", tx,ty+=15);
		g.drawString("iterate", tx,ty+=15);

		g.setColor(Color.red);
		g.setFont(f1);
		g.drawString("  Z(n+1) = ( Z(n) + C) / (1 + C * Z(n) * Z(n)* Z(n) )", tx,ty+=20);
		g.setFont(f3);
		g.setColor(Color.black);
		g.drawString("  in two versions Z1 and Z2 in the same time", tx,ty+=15);
		g.drawString("  with", tx,ty+=15);
		g.drawString("  C1 = Cxy * (1 + param * Z2)", tx,ty+=15);
		g.drawString("  C2 = Cpt * (1 - param * Z1)", tx,ty+=15);

		g.drawString("MANDELBRODTset: Starts iteration at every Point with X=0; Y=0; P=0, T=0", tx,ty+=20);
		g.drawString("Koordinates of picture:(Cx, Cy), break by rel.precision 1E-4 or if divergent", tx,ty+=15);

		g.drawString("JULIAset: Starts iteration at every Point with X=X0; Y=Y0; P=P0, T=T0", tx,ty+=20);
		g.drawString("with Cx = constant, Cy = constant, Cp = Cx, Ct = Cy for the whole picture", tx,ty+=15);
		g.drawString("Koordinates of picture:(X0, Y0), break by rel.precision 1E-4 or if divergent", tx,ty+=15);

		g.setColor(Color.blue);
		g.setFont(f1);
		g.drawString("JAVA-Code for colors of the 9 pictures:", tx,ty+=30);

		g.setFont(f3);
		g.setColor(Color.black);
		g.drawString("r = Math.sqrt(x*x + y*y);", tx,ty+=20);
		g.drawString("igr = 0;", tx,ty+=15);
		g.drawString("switch (Pict) {", tx,ty+=15);
		g.drawString("case 1: {igr = (int)(cFac * moduloI(numbIterat,(int)(256/cFac))); break; }", tx,ty+=15);
		g.drawString("case 2: {igr = (int)(cFac * moduloI(numbIterat,4)); break; }", tx,ty+=15);
		g.drawString("case 3: {igr = moduloI(numbIterat,255); break; }", tx,ty+=15);
		g.drawString("case 4: {if (x < 0) igr=255;if (Math.abs(x) < 1) igr=0;", tx,ty+=15);
		g.drawString("               if(Math.abs(x) > 1) igr=(int)(cFac*Math.log(Math.abs(x))-cadd); break; }", tx,ty+=15);
		g.drawString("case 5: {if (y < 0) igr=255;if (Math.abs(y) < 1) igr=0;", tx,ty+=15);
		g.drawString("               if (Math.abs(y) > 1) igr=(int)(cFac*Math.log(Math.abs(y))-cadd); break; }", tx,ty+=15);
		g.drawString("case 6: {if (r < 0) igr=255;if (Math.abs(r) < 1) igr=0; ", tx,ty+=15);
		g.drawString("               if (r > 1) igr=(int)(cFac*Math.log(r)-cadd); break; }", tx,ty+=15);
		g.drawString("case 7: {if (x > 0) igr=0;if (x < 0) igr=64; if (x > 1) igr=(int)(cFac*Math.log(x)-cadd); break; }", tx,ty+=15);
		g.drawString("case 8: {if (y > 0) igr=0;if (y < 0) igr=64; if (y > 1) igr=(int)(cFac*Math.log(y)-cadd); break; }", tx,ty+=15);
		g.drawString("case 9: {if (r < 0) igr=255;if (r < 1) igr=(int)(cFac*2*r-cadd);", tx,ty+=15);
		g.drawString("               if (r > 1) igr=0; break; }", tx,ty+=15);

		g.drawString("Author:  G.Mueller, info@alveo.de, ", 300,60);
		g.drawString("www.aladin24.de/applets/", 300,75);
		g.drawString("(C) AlveoLara 7/2001", 300,90);

}


//______________________________________________________________________________________





//______________________________________________________________________________________


	private void getTabSinus(int nr, int colmax, int[] coR,int[] coG,int[] coB) {
	// nr = 1 .. 13
	double max = (double)colmax;
	int colmaxh = (int)(max / 2);


	switch (nr) {


		case 1: {

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 2))) );
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 2: {

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 2))) );
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 3: {

		for (int j = 0; j < colmax+1; j++) {
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 2))) );
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 4: {

		for (int j = 0; j < colmax+1; j++) {
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 2))) );
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 5: {  // ohne Dreher

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 2))) );
			coG[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coB[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 3.5 ))) );
		}; break;
		}

		case 6: {

		for (int j = 0; j < colmax+1; j++) {
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 3.7))) );
			coB[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 1.7))) );
		}; break;
		}

		case 7: {	// gelb-braun-schwarz

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			coG[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coB[j] = 0;
		}; break;
		}

		case 8: {

		for (int j = 0; j < colmax+1; j++) {
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 3.7))) );
			coR[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 1.7))) );
		}; break;
		}

		case 9: {

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 4 ))) );
			coB[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 6 ))) );
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 10: {

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 6 ))) );
			coB[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 5 ))) );
			coG[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 11: {

		for (int j = 0; j < colmax+1; j++) {
			coG[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 4 ))) );
			coB[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 6 ))) );
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 12: {

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 4 ))) );
			coG[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 6 ))) );
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

		case 13: {

		for (int j = 0; j < colmax+1; j++) {
			coG[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 6 ))) );
			coR[j] = grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 5 ))) );
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max ))) );
		}; break;
		}

//14 andere Farbtabelle
//15 andere Farbtabelle


		case 16: {

		for (int j = 0; j < colmax+1; j++) {
			coB[j] = colmax - grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max ))) );
			coR[j] = colmax - grenz( (int)(colmaxh * (1 + Math.sin( ZPI * j / max * 3.7))) );
			coG[j] = grenz( (int)(colmaxh * (1 + Math.cos( ZPI * j / max * 1.7))) );
		}; break;
		}

		case 17: {	// orange-gelb-wei

		for (int j = 0; j < colmax+1; j++) {

			coB[j] = grenz(4*moduloI(j,64) );
			coG[j] = j; //colmax - grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			if (j<128)
			coR[j] = grenz(colmax - j);
			else
			coR[j] = j;

		}; break;
		}

		case 18: {	// orange-gelb

		for (int j = 0; j < colmax+1; j++) {
			coG[j] = grenz(2*moduloI(j,128) );
			coB[j] = colmax - j; //colmax - grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			coR[j] = grenz(colmax - moduloI(j,64) );
		}; break;
		}


		case 19: {	// hellblau-rosa

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz(2*moduloI(j,128) );
			coG[j] = colmax - j; //colmax - grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			coB[j] = grenz(colmax - moduloI(j,64) );
		}; break;
		}

		case 20: {	// hellblau, rosa, wei

		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz(4*moduloI(j,64) );
			coG[j] = j; //colmax - grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			if (j<128)
			coB[j] = grenz(colmax - j);
			else
			coB[j] = j;
		}; break;
		}

		case 21: {  // grn,wei,rot

		for (int j = 0; j < colmax+1; j++) {

			coR[j] = grenz(4*moduloI(j,64) );
			coB[j] = j; //colmax - grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			if (j<128)
			coG[j] = grenz(colmax - 2*j);
			else
			coG[j] = grenz(2*j);

		}; break;
		}

		case 22: {  // orange, wei, blauschwarz

		for (int j = 0; j < colmax+1; j++) {

				coB[j] = grenz(4*moduloI(j,64) );
				coG[j] = j; //colmax - grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
				if (j<128)
				coR[j] = grenz(colmax - 2*j);
				else
				coR[j] = grenz(2*j);

		}; break;
		}

		default: {


		for (int j = 0; j < colmax+1; j++) {
			coR[j] = grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			coG[j] = grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
			coB[j] = grenz( (int)(colmaxh * (1 + Math.cos( PI * j / max ))) );
		}; break;
		}

	} return;
	}


//______________________________________________________________________________________


	private void getTabIdeal(int iL, int comax,int[] cR, int[] cG,int[] cB) {


		// iL =   0..8

			int[] kR = new int[25];
			int[] kG = new int[25];
			int[] kB = new int[25];

			int laenge = 10, swR, swG, swB, k, kk, grupp;
			int L = moduloI(iL,8);


			switch (iL) {

				case 0: {

				kR[1] = 255; kR[2] =   0; kR[3] =   0; kR[4] = 255; kR[5] = 255;
				kG[1] = 255; kG[2] =   0; kG[3] = 255; kG[4] =   0; kG[5] = 255;
				kB[1] = 255; kB[2] = 255; kB[3] =   0; kB[4] =   0; kB[5] =   0;

				kR[6] =   0; kR[7] =   0; kR[8] =   0; kR[9] = 255; kR[10] = 255;
				kG[6] =   0; kG[7] = 255; kG[8] = 128; kG[9] = 255; kG[10] =   0;
				kB[6] =   0; kB[7] = 255; kB[8] =   0; kB[9] = 128; kB[10] = 255;
				laenge =10;
				break;
				}

				default: {

				kR[1] =   0; kR[2] = 255; kR[3] =   0; kR[4] =   0; kR[5] = 255;
				kG[1] = 255; kG[2] =   0; kG[3] = 255; kG[4] =   0; kG[5] = 255;
				kB[1] = 255; kB[2] =   0; kB[3] =   0; kB[4] = 160; kB[5] =   0;

				kR[6] =   0; kR[7] = 255; kR[8] = 255;
				kG[6] =   0; kG[7] = 128; kG[8] = 255;
				kB[6] =   0; kB[7] = 255; kB[8] = 255;
				laenge=8;
				break;
					}
				}

			int[] koR = new int [laenge];
			int[] koG = new int [laenge];
			int[] koB = new int [laenge];
				grupp = (int)(comax / (laenge));

					for (k = 0; k < laenge; k++) {
						koR[k] = kR[k];
						koG[k] = kG[k];
						koB[k] = kB[k];
					}

					int j=-1;
					for (k = 0; k < laenge; k++) {

						j++;
						if ((j+L) == laenge) {j = -L;}

						kR[k] = koR[j+L];
						kG[k] = koG[j+L];
						kB[k] = koB[j+L];

					}



					j=-1;
					for (k = 0; k < laenge; k++) {
					kk = k; if (k == (laenge - 1)) kk = -1;
						swR = (int)((kR[kk+1] - kR[k]) / grupp);
						swG = (int)((kG[kk+1] - kG[k]) / grupp);
						swB = (int)((kB[kk+1] - kB[k]) / grupp);



						j++;
						cR[j] = kR[k];
						cG[j] = kG[k];
						cB[j] = kB[k];

						for (int i=1; i < grupp; i++) {

							if (j < (comax+1)) j++;
							cR[j] = grenz(cR[j-1] + swR);
							cG[j] = grenz(cG[j-1] + swG);
							cB[j] = grenz(cB[j-1] + swB);
							}
					};

					if (j<comax+1) {
						while (j < comax) {
						j++;
						cR[j] = cR[j-1];
						cG[j] = cG[j-1];
						cB[j] = cB[j-1]; }
					}

		return;
		}


//______________________________________________________________________________________


	private  void getTabKontrast(int iL, int comax,int[] cR, int[] cG,int[] cB) {

			int L = moduloI(iL,14);
			int k = -1, add = 0;
			int[] kR = {255, 128, 255, 255,   0, 255, 0,   0, 255, 128,   0, 255,   0, 250 };
			int[] kG = {  0, 255,   0, 255,   0, 255, 0, 255, 128, 255, 128, 255,   0, 250 };
			int[] kB = {255, 255,   0,   0, 255, 255, 0,   0,   0, 255,   0, 128, 255, 250 };

			for (int j = 0; j < (comax + 1); j++) {

				if ((k + L) == kR.length-1) {k = -L-1; add +=3; };

				k++;
				cR[j] = grenz(kR[k+L] + add);
				cG[j] = grenz(kG[k+L] + add);
				cB[j] = grenz(kB[k+L] + add);
			};


		return;
		}

	//______________________________________________________________________________________


		private void getPresentModus( int iL, int comax,int[] cR, int[] cG,int[] cB) {
		// iL ist Schrittgre

				int L, k=-1;
				int[] c0R = new int[comax+1];
				int[] c0G = new int[comax+1];
				int[] c0B = new int[comax+1];
				L = moduloI(iL, comax);

				for (int j = 0; j < (comax + 1); j++) {

					c0R[j] = cR[j];
					c0G[j] = cG[j];
					c0B[j] = cB[j];
				}


					for (int j = 0; j < (comax + 1); j++) {

						if ((k + L) == comax) k = -L-1;
						k++;
						cR[j] = c0R[k+L];
						cG[j] = c0G[k+L];
						cB[j] = c0B[k+L];
					}; // for j



				return;
			}


//______________________________________________________________________________________



	private int moduloI (int a, int b) {
		int m = a - b * (int)Math.rint(a/b);
	return m;
	}


//______________________________________________________________________________________


	private void delayStop (int delaytime) {
		if (delaytime > 1) {
		double haha = 0;
		for (int del = 1; del < delaytime; del++) {
		for (int del2 = 1; del2 < delaytime; del2++) {
			haha = Math.sqrt(5.8);
		}
		}
		};
	}




}

//****************************************************************************************
//****************************************************************************************
